#!/usr/bin/env python
# -*- coding: utf-8 -*-

import os
import pwd
import re
import ldap 
import commands

# Obtendo dados do usuário.

class Controladora():
	
	def conectar_ldap(self):
		ldap_con = None
		try:
			ldap_con = ldap.initialize("ldap://apolo.dimap.ufrn.br:389/")
			ldap_con.protocol_version = ldap.VERSION3  
										
			username = "cn=admin,dc=lcc,dc=ufrn,dc=br"
			password  = "33@cd@dbldl"
			
			ldap_con.simple_bind(username, password)

		except ldap.LDAPError, e:
			print e
		
		return ldap_con 

	def formulario(self):
		
		login = None
		given_name = None
		surname = None
		matricula = None
		curso_cargo = None
		
		# Obtendo o nome do usuário.
		 
		while True:
			login = raw_input("Digite o login do usuário: ")
			if not re.match("^[a-z][a-z0-9_]{3,20}$", login):
				print "[erro] Um login deve conter apenas letras, números, _; começar com caractere; e ter entre 3 e 20 caracteres!" 
			else:
				try:
					informacoes_usuario = pwd.getpwnam(login)
					print "[erro] Usuário já existe! Tente outro login!"
				except KeyError:
					# Login livre para cadastro.
					break

		# Obtendo o given name do usuário.
		
		while True:
			given_name = raw_input("Digite o given name (primeiro nome) do usuário: ")
			if given_name.strip() == '':
				print "[erro] Digite o given name do usuário!"
			elif len(given_name) < 3:
				print "[erro] Digute um given name válido!"
			else:
				break

		# Obtendo o surname do usuário.

		while True:
			surname = raw_input("Digite o surname (último nome) do usuário: ")
			if surname.strip() == '':
				print "[erro] Digite o surname do usuário!"
			elif len(surname) < 3:
				print "[erro] Digute um nome válido!"
			else:
				break
																					   
		# Obtendo a matrícula.

		while True:
			matricula = raw_input("Digite a matrícula do usuário: ")
			if not re.match("\d{5,20}", matricula):
				print "A matrícula deve conter apenas números e entre 5 e 20 números."        
			else:
				break
		
		# Obtendo o curso.
		
		while True:
			opcoes = """
			Cursos
			
			(c) Ciência da Computação
			(e) Engenharia de Software
			
			Cargos
			
			(t) Técnico Administrativo
			(p) Professor  
			"""
			print opcoes
			opcao = raw_input("Escola a opção do curso acima: ")
			
			if opcao == 'c':
				curso_cargo  = "Ciência da Computação"
				break
			elif opcao == 'e':
				curso_cargo = "Engenharia de Software"
				break
			elif opcao == 't':
				curso_cargo = "Técnico Administrativo"
				break
			elif opcao == 'p':
				curso_cargo = "Professor"
				break
			else:
				print "[erro] Opção inválida! Escolha umas das opções listadas."
					
		usuario = Usuario(login, given_name, surname, matricula, curso_cargo)
		return usuario

	def inserir_usuario_ldap(self, usuario):
		
		os.system("smbldap-useradd -am -P %s" %usuario.login)
		
		ldap_con = self.conectar_ldap()
				
		atributos = [
					(ldap.MOD_ADD, 'mail', '%s@lcc.ufrn.br' %usuario.login),
					(ldap.MOD_ADD, 'employeeNumber', usuario.matricula),
					(ldap.MOD_ADD, 'employeeType', usuario.curso_cargo),

					(ldap.MOD_REPLACE, 'displayName', usuario.given_name),			
					(ldap.MOD_REPLACE, 'gecos', usuario.given_name),
					(ldap.MOD_REPLACE, 'cn', '%s %s' %(usuario.given_name, usuario.surname)),
					(ldap.MOD_REPLACE, 'givenName', usuario.given_name),
					(ldap.MOD_REPLACE, 'sn', usuario.surname),
					]
					
		ldap_con.modify_s("uid=%s,ou=people,dc=lcc,dc=ufrn,dc=br" %usuario.login, atributos)
		ldap_con.unbind_s()
		
	def pesquisar_informacoes(self):

		base_dn = "ou=people,dc=lcc,dc=ufrn,dc=br"
		search_scope = ldap.SCOPE_SUBTREE
		retrieve_attributes = None 
		search_filter = "uid=%s" %usuario.login
		
		try:
			resultados = ldap_con.search_s(base_dn, search_scope, search_filter, retrieve_attributes)
			for resultado in resultados:
				print resultado
		except ldap.LDAPError, e:
			print e

	def realizar_configuracoes_adicionais(self, usuario):

		# Alteração de quotas

		soft = 1000000
		hard = 1200000

		resultado = commands.getstatusoutput("setquota -u %s %d %d 0 0 -a" %(usuario.login, soft, hard))

		if resultado[0] != 0:
			print "[erro] Não foi possível aterar a quota de arquivos."	

		# Criação da public_html e alteração das permissões

		if not os.path.isdir("/home/%s/public_html" %usuario.login):
			os.mkdir("/home/%s/public_html" %usuario.login)
	
			html = open("/home/%s/public_html/index.html" %usuario.login, 'w')
			html.write("<h1> %s homepage </h1>" %usuario.given_name)
			html.close()

			os.chmod("/home/%s/public_html" %usuario.login, 0755)
			os.chmod("/home/%s/public_html/index.html" %usuario.login, 0755)
			os.chmod("/home/%s" %usuario.login, 0701)

			informacoes_usuario = pwd.getpwnam(usuario.login)
			uid = informacoes_usuario[2]
			gid = informacoes_usuario[3]

			os.chown("/home/%s/public_html" %usuario.login, uid, gid)
			os.chown("/home/%s/public_html/index.html" %usuario.login, uid, gid)

		fila_contas_emails = open("fila-contas-email.txt", "a")
		fila_contas_emails.write("\nGiven Name: %s | Surname: %s | E-mail: %s" %(usuario.login, usuario.given_name, usuario.surname))
		fila_contas_emails.close() 

		print "Cadastro realizado com sucesso."

	def realizar_cadastro_completo(self):
		usuario = self.formulario()
		self.inserir_usuario_ldap(usuario)   
		self.realizar_configuracoes_adicionais(usuario)

class Usuario():

	def __init__(self, login, given_name, surname, matricula, curso_cargo):
		self.login = login
		self.given_name = given_name
		self.surname = surname
		self.matricula = matricula
		self.curso_cargo = curso_cargo


if __name__ == '__main__':

	# Verifica se é o 'root' que está executando este script

	if os.getuid() == 0:
		controladora = Controladora()

	else:
		print "[erro] Este script deve ser executado como root."
