from django.conf.urls import patterns, include, url

from django.contrib import admin
from django.conf import settings
admin.autodiscover()

from django.conf.urls.static import static

urlpatterns = patterns('',

	url(r'^media/(.*)$', 'django.views.static.serve', {'document_root': settings.MEDIA_ROOT}),
	url(r'^static/(.*)$', 'django.views.static.serve', {'document_root': settings.STATIC_ROOT}),


	# Views do Frontend.

    url(r'^$', 'ponto.views.pagina_inicial', name='pagina_inicial'),
    
    url(r'^autenticar/$', 'ponto.views.autenticar', name='autenticar'),
    url(r'^sair/$', 'ponto.views.sair', name='sair'),
    
    url(r'^batidasponto/$', 'ponto.views.batidasponto', name='batidaspont'),
    url(r'^resumodiario/$', 'ponto.views.resumodiario', name='resumodiario'),
    url(r'^resumosemanal/$', 'ponto.views.resumosemanal', name='resumosemanal'),
    
    url(r'^relatorio_individual/$', 'ponto.views.relatorio_individual', name='relatorio_individual'),
	url(r'^relatorio_individual/(?P<funcionario>\w+)/(?P<mes>\d{2})/(?P<ano>\d{4})/$',  'ponto.views.relatorio_individual', name='relatorio_individual'),
	
    url(r'^relatorio_geral/$', 'ponto.views.relatorio_geral', name='relatorio_geral'),  
    url(r'^relatorio_geral/(?P<mes>\d{2})/(?P<ano>\d{4})/$',  'ponto.views.relatorio_geral', name='relatorio_geral'),
    
    #url(r'^comentario/$', 'ponto.views.comentario', name='comentario'),  
    
    
    url(r'^listar_comentarios/$', 'ponto.views.listar_comentarios', name='listar_comentarios'), 

	url(r'^consultar_comentario/(?P<dia>\d{2})/(?P<mes>\d{2})/(?P<ano>\d{4})/$', 'ponto.views.consultar_comentario', name='consultar_comentario'), 
    url(r'^adicionar_comentario/(?P<dia>\d{2})/(?P<mes>\d{2})/(?P<ano>\d{4})/$', 'ponto.views.adicionar_comentario', name='adicionar_comentario'),   
	url(r'^editar_comentario/(?P<dia>\d{2})/(?P<mes>\d{2})/(?P<ano>\d{4})/$', 'ponto.views.editar_comentario', name='editar_comentario'),   
    url(r'^remover_comentario/(?P<dia>\d{2})/(?P<mes>\d{2})/(?P<ano>\d{4})/$', 'ponto.views.remover_comentario', name='remover_comentario'),  
      
    url(r'^forcar_sincronizacao/$', 'ponto.views.forcar_sincronizacao', name='forcar_sincronizacao'),
    
    url(r'^aprovar_comentarios/$', 'ponto.views.aprovar_comentarios', name='aprovar_comentarios'),
    
    url(r'^selecionar_funcionario/$', 'ponto.views.selecionar_funcionario', name='selecionar_funcionario'),
    
    url(r'^admin/', include(admin.site.urls)),


) + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)


