#!/usr/bin/env python
# -*- coding: utf-8 -*-

from django.contrib import admin
from models import *

"""
class FuncionarioAdmin(admin.ModelAdmin):
	list_display = ('nome', 'matricula',)
	search_fields = ('nome', 'matricula',)
	list_filter = ('nome', 'matricula',)
	ordering = ('nome',)
"""
	
class BatidaPontoAdmin(admin.ModelAdmin):
	list_display = ('funcionario', 'momento_batidaponto',)
	search_fields = ('funcionario', 'momento_batidaponto',)
	list_filter = ('funcionario', 'momento_batidaponto',)
	ordering = ('-momento_batidaponto',)
	
class SincronizacaoAdmin(admin.ModelAdmin):
	list_display = ('data_hora',)
	search_fields = ('data_hora',)
	list_filter = ('data_hora',)
	ordering = ('-data_hora',)		
	
	
class ResumoDiarioAdmin(admin.ModelAdmin):
	list_display = ('funcionario','data','horas_trabalhadas')
	search_fields = ('funcionario','data','horas_trabalhadas')
	list_filter = ('funcionario','data',)
	ordering = ('-data',)
	
	
class ResumoSemanalAdmin(admin.ModelAdmin):
	list_display = ('funcionario','segunda_feira','horas_trabalhadas')
	search_fields = ('funcionario','segunda_feira','horas_trabalhadas')
	list_filter = ('funcionario','segunda_feira',)
	ordering = ('-segunda_feira',)
	
class ComentarioAdmin(admin.ModelAdmin):
	list_display = ('funcionario', 'data','texto')
	search_fields = ('funcionario', 'data','texto')
	list_filter = ('funcionario', 'data','texto')
	ordering = ('funcionario', '-data','texto')
	
class ObservacaoAdmin(admin.ModelAdmin):
	list_display = ('data','texto')
	search_fields = ('data','texto')
	list_filter = ('data','texto')
	ordering = ('-data','texto')
	

from django.contrib.auth.admin import UserAdmin
from django.utils.translation import ugettext_lazy as _

from forms import FuncionarioChangeForm, FuncionarioCreationForm

class FuncionarioAdmin(UserAdmin):
	fieldsets = ( (None, {'fields': ('username','first_name','last_name','matricula','email','horario_inicial_entrada','horario_final_saida', 'password')}), (_('Permissions'), {'fields': ('is_active', 'is_staff', 'is_superuser', 'groups', 'user_permissions')}), (_('Important dates'), {'fields': ('last_login', 'date_joined')}),)
	add_fieldsets = ((None, {'classes': ('wide',), 'fields': ('username','first_name','last_name','matricula', 'email','horario_inicial_entrada','horario_final_saida','password1', 'password2')}),)

	# The forms to add and change user instances
	form = FuncionarioChangeForm
	add_form = FuncionarioCreationForm

	# The fields to be used in displaying the User model.
	# These override the definitions on the base UserAdmin
	# that reference specific fields on auth.User.
	list_display = ('username', 'first_name','last_name', 'matricula','email', 'is_staff')
	list_filter = ('is_staff', 'is_superuser', 'is_active', 'groups')
	search_fields = ('email',)
	ordering = ('first_name',)
	filter_horizontal = ('groups', 'user_permissions',)



#admin.site.register(Funcionario, FuncionarioAdmin)
admin.site.register(Funcionario, FuncionarioAdmin)
admin.site.register(BatidaPonto, BatidaPontoAdmin)
admin.site.register(Sincronizacao, SincronizacaoAdmin)
admin.site.register(Comentario, ComentarioAdmin)
admin.site.register(Observacao, ObservacaoAdmin)

#admin.site.register(ResumoDiario, ResumoDiarioAdmin)
#admin.site.register(ResumoSemanal, ResumoSemanalAdmin)
