# -*- coding: utf-8 -*-
from south.utils import datetime_utils as datetime
from south.db import db
from south.v2 import SchemaMigration
from django.db import models


class Migration(SchemaMigration):

    def forwards(self, orm):
        # Adding model 'Funcionario'
        db.create_table(u'ponto_funcionario', (
            (u'id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('password', self.gf('django.db.models.fields.CharField')(max_length=128)),
            ('last_login', self.gf('django.db.models.fields.DateTimeField')(default=datetime.datetime.now)),
            ('is_superuser', self.gf('django.db.models.fields.BooleanField')(default=False)),
            ('username', self.gf('django.db.models.fields.CharField')(unique=True, max_length=30)),
            ('first_name', self.gf('django.db.models.fields.CharField')(max_length=30, blank=True)),
            ('last_name', self.gf('django.db.models.fields.CharField')(max_length=30, blank=True)),
            ('matricula', self.gf('django.db.models.fields.CharField')(unique=True, max_length=20)),
            ('horario_inicial_entrada', self.gf('django.db.models.fields.TimeField')(max_length=20)),
            ('horario_final_saida', self.gf('django.db.models.fields.TimeField')(max_length=20)),
            ('email', self.gf('django.db.models.fields.EmailField')(unique=True, max_length=255, db_index=True)),
            ('is_staff', self.gf('django.db.models.fields.BooleanField')(default=False)),
            ('is_active', self.gf('django.db.models.fields.BooleanField')(default=True)),
            ('date_joined', self.gf('django.db.models.fields.DateTimeField')(default=datetime.datetime.now)),
        ))
        db.send_create_signal(u'ponto', ['Funcionario'])

        # Adding M2M table for field groups on 'Funcionario'
        m2m_table_name = db.shorten_name(u'ponto_funcionario_groups')
        db.create_table(m2m_table_name, (
            ('id', models.AutoField(verbose_name='ID', primary_key=True, auto_created=True)),
            ('funcionario', models.ForeignKey(orm[u'ponto.funcionario'], null=False)),
            ('group', models.ForeignKey(orm[u'auth.group'], null=False))
        ))
        db.create_unique(m2m_table_name, ['funcionario_id', 'group_id'])

        # Adding M2M table for field user_permissions on 'Funcionario'
        m2m_table_name = db.shorten_name(u'ponto_funcionario_user_permissions')
        db.create_table(m2m_table_name, (
            ('id', models.AutoField(verbose_name='ID', primary_key=True, auto_created=True)),
            ('funcionario', models.ForeignKey(orm[u'ponto.funcionario'], null=False)),
            ('permission', models.ForeignKey(orm[u'auth.permission'], null=False))
        ))
        db.create_unique(m2m_table_name, ['funcionario_id', 'permission_id'])

        # Adding model 'BatidaPonto'
        db.create_table(u'ponto_batidaponto', (
            (u'id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('funcionario', self.gf('django.db.models.fields.related.ForeignKey')(to=orm['ponto.Funcionario'])),
            ('momento_batidaponto', self.gf('django.db.models.fields.DateTimeField')(unique=True)),
        ))
        db.send_create_signal(u'ponto', ['BatidaPonto'])

        # Adding unique constraint on 'BatidaPonto', fields ['funcionario', 'momento_batidaponto']
        db.create_unique(u'ponto_batidaponto', ['funcionario_id', 'momento_batidaponto'])

        # Adding model 'Sincronizacao'
        db.create_table(u'ponto_sincronizacao', (
            (u'id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('data_hora', self.gf('django.db.models.fields.DateTimeField')()),
        ))
        db.send_create_signal(u'ponto', ['Sincronizacao'])

        # Adding model 'Comentario'
        db.create_table(u'ponto_comentario', (
            (u'id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('funcionario', self.gf('django.db.models.fields.related.ForeignKey')(to=orm['ponto.Funcionario'])),
            ('data', self.gf('django.db.models.fields.DateField')()),
            ('texto', self.gf('django.db.models.fields.TextField')(max_length='500')),
            ('arquivo_anexo', self.gf('django.db.models.fields.files.FileField')(max_length='500', null=True, blank=True)),
        ))
        db.send_create_signal(u'ponto', ['Comentario'])

        # Adding model 'Observacao'
        db.create_table(u'ponto_observacao', (
            (u'id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('data', self.gf('django.db.models.fields.DateField')()),
            ('texto', self.gf('django.db.models.fields.TextField')(max_length='500')),
        ))
        db.send_create_signal(u'ponto', ['Observacao'])


    def backwards(self, orm):
        # Removing unique constraint on 'BatidaPonto', fields ['funcionario', 'momento_batidaponto']
        db.delete_unique(u'ponto_batidaponto', ['funcionario_id', 'momento_batidaponto'])

        # Deleting model 'Funcionario'
        db.delete_table(u'ponto_funcionario')

        # Removing M2M table for field groups on 'Funcionario'
        db.delete_table(db.shorten_name(u'ponto_funcionario_groups'))

        # Removing M2M table for field user_permissions on 'Funcionario'
        db.delete_table(db.shorten_name(u'ponto_funcionario_user_permissions'))

        # Deleting model 'BatidaPonto'
        db.delete_table(u'ponto_batidaponto')

        # Deleting model 'Sincronizacao'
        db.delete_table(u'ponto_sincronizacao')

        # Deleting model 'Comentario'
        db.delete_table(u'ponto_comentario')

        # Deleting model 'Observacao'
        db.delete_table(u'ponto_observacao')


    models = {
        u'auth.group': {
            'Meta': {'object_name': 'Group'},
            u'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'name': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '80'}),
            'permissions': ('django.db.models.fields.related.ManyToManyField', [], {'to': u"orm['auth.Permission']", 'symmetrical': 'False', 'blank': 'True'})
        },
        u'auth.permission': {
            'Meta': {'ordering': "(u'content_type__app_label', u'content_type__model', u'codename')", 'unique_together': "((u'content_type', u'codename'),)", 'object_name': 'Permission'},
            'codename': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'content_type': ('django.db.models.fields.related.ForeignKey', [], {'to': u"orm['contenttypes.ContentType']"}),
            u'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'name': ('django.db.models.fields.CharField', [], {'max_length': '50'})
        },
        u'contenttypes.contenttype': {
            'Meta': {'ordering': "('name',)", 'unique_together': "(('app_label', 'model'),)", 'object_name': 'ContentType', 'db_table': "'django_content_type'"},
            'app_label': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            u'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'model': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'name': ('django.db.models.fields.CharField', [], {'max_length': '100'})
        },
        u'ponto.batidaponto': {
            'Meta': {'unique_together': "(('funcionario', 'momento_batidaponto'),)", 'object_name': 'BatidaPonto'},
            'funcionario': ('django.db.models.fields.related.ForeignKey', [], {'to': u"orm['ponto.Funcionario']"}),
            u'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'momento_batidaponto': ('django.db.models.fields.DateTimeField', [], {'unique': 'True'})
        },
        u'ponto.comentario': {
            'Meta': {'object_name': 'Comentario'},
            'arquivo_anexo': ('django.db.models.fields.files.FileField', [], {'max_length': "'500'", 'null': 'True', 'blank': 'True'}),
            'data': ('django.db.models.fields.DateField', [], {}),
            'funcionario': ('django.db.models.fields.related.ForeignKey', [], {'to': u"orm['ponto.Funcionario']"}),
            u'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'texto': ('django.db.models.fields.TextField', [], {'max_length': "'500'"})
        },
        u'ponto.funcionario': {
            'Meta': {'object_name': 'Funcionario'},
            'date_joined': ('django.db.models.fields.DateTimeField', [], {'default': 'datetime.datetime.now'}),
            'email': ('django.db.models.fields.EmailField', [], {'unique': 'True', 'max_length': '255', 'db_index': 'True'}),
            'first_name': ('django.db.models.fields.CharField', [], {'max_length': '30', 'blank': 'True'}),
            'groups': ('django.db.models.fields.related.ManyToManyField', [], {'symmetrical': 'False', 'related_name': "u'user_set'", 'blank': 'True', 'to': u"orm['auth.Group']"}),
            'horario_final_saida': ('django.db.models.fields.TimeField', [], {'max_length': '20'}),
            'horario_inicial_entrada': ('django.db.models.fields.TimeField', [], {'max_length': '20'}),
            u'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'is_active': ('django.db.models.fields.BooleanField', [], {'default': 'True'}),
            'is_staff': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'is_superuser': ('django.db.models.fields.BooleanField', [], {'default': 'False'}),
            'last_login': ('django.db.models.fields.DateTimeField', [], {'default': 'datetime.datetime.now'}),
            'last_name': ('django.db.models.fields.CharField', [], {'max_length': '30', 'blank': 'True'}),
            'matricula': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '20'}),
            'password': ('django.db.models.fields.CharField', [], {'max_length': '128'}),
            'user_permissions': ('django.db.models.fields.related.ManyToManyField', [], {'symmetrical': 'False', 'related_name': "u'user_set'", 'blank': 'True', 'to': u"orm['auth.Permission']"}),
            'username': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '30'})
        },
        u'ponto.observacao': {
            'Meta': {'object_name': 'Observacao'},
            'data': ('django.db.models.fields.DateField', [], {}),
            u'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'texto': ('django.db.models.fields.TextField', [], {'max_length': "'500'"})
        },
        u'ponto.sincronizacao': {
            'Meta': {'object_name': 'Sincronizacao'},
            'data_hora': ('django.db.models.fields.DateTimeField', [], {}),
            u'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'})
        }
    }

    complete_apps = ['ponto']